
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/intuition.h>
#include <proto/screennotify.h>
#include <libraries/screennotify.h>

struct Library *ScreenNotifyBase;


struct Window *open_window (long x,long y)

{
return (OpenWindowTags (NULL,
		WA_Left,x,WA_Top,y,
		WA_Width,320,WA_Height,100,
		WA_Flags,WFLG_CLOSEGADGET | WFLG_DRAGBAR | WFLG_DEPTHGADGET | WFLG_ACTIVATE | WFLG_NOCAREREFRESH,
		WA_IDCMP,IDCMP_CLOSEWINDOW | IDCMP_VANILLAKEY,
		TAG_END));
}



int main (void)

{
struct MsgPort *port;
APTR handle;
struct ScreenNotifyMessage *nfymsg;
struct Window *win;
struct IntuiMessage *winmsg;
ULONG sigs;
ULONG winsig;
ULONG nfysig;
long x = 80;
long y = 80;
BOOL cont;

ScreenNotifyBase = OpenLibrary ("screennotify.library",0);
if (!ScreenNotifyBase)
	{
	Printf ("need screennotify.library\n");
	return (20);
	}

if (port = CreateMsgPort ())
	{
	if (handle = AddWorkbenchClient (port,0))
		{
		if (win = open_window (x,y))
			{

			cont = TRUE;

			nfysig = 1L << port->mp_SigBit;

			while (cont)
				{
				winsig = win ? 1L << win->UserPort->mp_SigBit : 0;

				sigs = Wait (nfysig | winsig | SIGBREAKF_CTRL_C);

				if (sigs & SIGBREAKF_CTRL_C)
					cont = FALSE;

				if (sigs & winsig)
					{
					while (winmsg = (struct IntuiMessage *) GetMsg (win->UserPort))
						{
						switch (winmsg->Class)
							{
						case IDCMP_VANILLAKEY:
							if (winmsg->Code == 0x1b)
								cont = FALSE;
							break;
						case IDCMP_CLOSEWINDOW:
							cont = FALSE;
							break;
							}
						ReplyMsg ((struct Message *) winmsg);
						}
					}

				if (sigs & nfysig)
					while (nfymsg = (struct ScreenNotifyMessage *) GetMsg (port))
						{
						if (nfymsg->snm_Type == SCREENNOTIFY_TYPE_WORKBENCH)
							switch ((ULONG)nfymsg->snm_Value)
								{
							case FALSE: /* close workbench */
								if (win)
									{
									x = win->LeftEdge;
									y = win->TopEdge;
									CloseWindow (win);
									win = NULL;
									}
								break;
							case TRUE: /* open workbench */
								win = open_window (x,y);
								if (!win)
									cont = FALSE;
								break;
								}
						ReplyMsg ((struct Message *)nfymsg);
						}
				}

			if (win)
				CloseWindow (win);
			}

		while (!RemWorkbenchClient (handle)) Delay (10);

		while (nfymsg = (struct ScreenNotifyMessage *) GetMsg (port))
			ReplyMsg ((struct Message *)nfymsg);
		}
	DeleteMsgPort (port);
	}

return (0);
}


